---
title: "CLI Command Reference"
description: "Complete reference for all Kilo CLI commands and subcommands"
---

# CLI Command Reference

<!-- Auto-generated by script/generate-cli-docs.ts — do not edit manually -->

## kilo acp

```
start ACP (Agent Client Protocol) server

Options:
  --help         Show help  [boolean]
  --version      Show version number  [boolean]
  --port         port to listen on  [number] [default: 0]
  --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
  --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
  --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
  --cors         additional domains to allow for CORS  [array] [default: []]
  --cwd          working directory  [string] [default: "."]
```

## kilo mcp

```
manage MCP (Model Context Protocol) servers

Commands:
  kilo mcp add            add an MCP server
  kilo mcp list           list MCP servers and their status  [aliases: ls]
  kilo mcp auth [name]    authenticate with an OAuth-enabled MCP server
  kilo mcp logout [name]  remove OAuth credentials for an MCP server
  kilo mcp debug <name>   debug OAuth connection for an MCP server

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo mcp add

```
add an MCP server

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo mcp list

```
list MCP servers and their status

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo mcp auth

```
authenticate with an OAuth-enabled MCP server

Commands:
  kilo mcp auth list  list OAuth-capable MCP servers and their auth status  [aliases: ls]

Positionals:
  name  name of the MCP server  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo mcp auth list

```
list OAuth-capable MCP servers and their auth status

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo mcp logout

```
remove OAuth credentials for an MCP server

Positionals:
  name  name of the MCP server  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo mcp debug

```
debug OAuth connection for an MCP server

Positionals:
  name  name of the MCP server  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo [project]

```
start kilo tui

Positionals:
  project  path to start kilo in  [string]

Options:
      --help         Show help  [boolean]
      --version      Show version number  [boolean]
      --port         port to listen on  [number] [default: 0]
      --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
      --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
      --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
      --cors         additional domains to allow for CORS  [array] [default: []]
  -m, --model        model to use in the format of provider/model  [string]
  -c, --continue     continue the last session  [boolean]
  -s, --session      session id to continue  [string]
      --fork         fork the session when continuing (use with --continue or --session)  [boolean]
      --cloud-fork   fetch session from cloud and continue locally (use with --session)  [boolean]
      --prompt       prompt to use  [string]
      --agent        agent to use  [string]
```

## kilo attach

```
attach to a running kilo server

Positionals:
  url  http://localhost:4096  [string]

Options:
      --help        Show help  [boolean]
      --version     Show version number  [boolean]
      --dir         directory to run in  [string]
  -c, --continue    continue the last session  [boolean]
  -s, --session     session id to continue  [string]
      --fork        fork the session when continuing (use with --continue or --session)  [boolean]
      --cloud-fork  fetch session from cloud and continue locally (use with --session)  [boolean]
  -p, --password    basic auth password (defaults to KILO_SERVER_PASSWORD)  [string]
  -u, --username    basic auth username (defaults to KILO_SERVER_USERNAME or 'kilo')  [string]
```

## kilo run

```
run kilo with a message

Positionals:
  message  message to send  [string] [default: []]

Options:
      --help                          Show help  [boolean]
      --version                       Show version number  [boolean]
      --command                       the command to run, use message for args  [string]
  -c, --continue                      continue the last session  [boolean]
  -s, --session                       session id to continue  [string]
      --fork                          fork the session before continuing (requires --continue or --session)  [boolean]
      --cloud-fork                    fetch session from cloud and continue locally (use with --session)  [boolean]
      --share                         share the session  [boolean]
  -m, --model                         model to use in the format of provider/model  [string]
      --agent                         agent to use  [string]
      --format                        format: default (formatted) or json (raw JSON events)  [string] [choices: "default", "json"] [default: "default"]
  -f, --file                          file(s) to attach to message  [array]
      --title                         title for the session (uses truncated prompt if no value provided)  [string]
      --attach                        attach to a running kilo server (e.g., http://localhost:4096)  [string]
  -p, --password                      basic auth password (defaults to KILO_SERVER_PASSWORD)  [string]
  -u, --username                      basic auth username (defaults to KILO_SERVER_USERNAME or 'kilo')  [string]
      --dir                           directory to run in, path on remote server if attaching  [string]
      --port                          port for the local server (defaults to random port if no value provided)  [number]
      --variant                       model variant (provider-specific reasoning effort, e.g., high, max, minimal)  [string]
      --thinking                      show thinking blocks  [boolean]
      --replay                        replay visible session history on interactive resume  [boolean] [default: false]
      --replay-limit                  cap visible interactive replay to the newest N messages  [number]
  -i, --interactive                   run in direct interactive split-footer mode  [boolean] [default: false]
      --dangerously-skip-permissions  auto-approve permissions that are not explicitly denied (dangerous!)  [boolean] [default: false]
      --auto                          auto-approve all permissions (for autonomous/pipeline usage)  [boolean] [default: false]
      --demo                          enable direct interactive demo slash commands; pass one as the message to run it immediately  [boolean] [default: false]
```

## kilo debug

```
debugging and troubleshooting tools

Commands:
  kilo debug config        show resolved configuration
  kilo debug lsp           LSP debugging utilities
  kilo debug rg            ripgrep debugging utilities
  kilo debug file          file system debugging utilities
  kilo debug scrap         list all known projects
  kilo debug skill         list all available skills
  kilo debug snapshot      snapshot debugging utilities
  kilo debug startup       print startup timing
  kilo debug agent <name>  show agent configuration details
  kilo debug v2            debug v2 catalog and built-in plugins
  kilo debug info          show debug information
  kilo debug paths         show global paths (data, config, cache, state)
  kilo debug wait          wait indefinitely (for debugging)

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug config

```
show resolved configuration

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug lsp

```
LSP debugging utilities

Commands:
  kilo debug lsp diagnostics <file>      get diagnostics for a file
  kilo debug lsp symbols <query>         search workspace symbols
  kilo debug lsp document-symbols <uri>  get symbols from a document

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug lsp diagnostics

```
get diagnostics for a file

Positionals:
  file  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug lsp symbols

```
search workspace symbols

Positionals:
  query  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug lsp document-symbols

```
get symbols from a document

Positionals:
  uri  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug rg

```
ripgrep debugging utilities

Commands:
  kilo debug rg tree              show file tree using ripgrep
  kilo debug rg files             list files using ripgrep
  kilo debug rg search <pattern>  search file contents using ripgrep

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug rg tree

```
show file tree using ripgrep

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --limit  [number]
```

### kilo debug rg files

```
list files using ripgrep

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --query    Filter files by query  [string]
  --glob     Glob pattern to match files  [string]
  --limit    Limit number of results  [number]
```

### kilo debug rg search

```
search file contents using ripgrep

Positionals:
  pattern  Search pattern  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --glob     File glob patterns  [array]
  --limit    Limit number of results  [number]
```

### kilo debug file

```
file system debugging utilities

Commands:
  kilo debug file read <path>     read file contents as JSON
  kilo debug file status          show file status information
  kilo debug file list <path>     list files in a directory
  kilo debug file search <query>  search files by query
  kilo debug file tree [dir]      show directory tree

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug file read

```
read file contents as JSON

Positionals:
  path  File path to read  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug file status

```
show file status information

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug file list

```
list files in a directory

Positionals:
  path  File path to list  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug file search

```
search files by query

Positionals:
  query  Search query  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug file tree

```
show directory tree

Positionals:
  dir  Directory to tree  [string] [default: "."]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug scrap

```
list all known projects

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug skill

```
list all available skills

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug snapshot

```
snapshot debugging utilities

Commands:
  kilo debug snapshot track         track current snapshot state
  kilo debug snapshot patch <hash>  show patch for a snapshot hash
  kilo debug snapshot diff <hash>   show diff for a snapshot hash

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug snapshot track

```
track current snapshot state

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug snapshot patch

```
show patch for a snapshot hash

Positionals:
  hash  hash  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug snapshot diff

```
show diff for a snapshot hash

Positionals:
  hash  hash  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug startup

```
print startup timing

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug agent

```
show agent configuration details

Positionals:
  name  Agent name  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --tool     Tool id to execute  [string]
  --params   Tool params as JSON or a JS object literal  [string]
```

### kilo debug v2

```
debug v2 catalog and built-in plugins

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug info

```
show debug information

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug paths

```
show global paths (data, config, cache, state)

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo debug wait

```
wait indefinitely (for debugging)

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo auth

```
manage AI providers and credentials

Commands:
  kilo auth list         list providers and credentials  [aliases: ls]
  kilo auth login [url]  log in to a provider
  kilo auth logout       log out from a configured provider

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo auth list

```
list providers and credentials

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo auth login

```
log in to a provider

Positionals:
  url  kilo auth provider  [string]

Options:
      --help      Show help  [boolean]
      --version   Show version number  [boolean]
  -p, --provider  provider id or name to log in to (skips provider selection)  [string]
  -m, --method    login method label (skips method selection)  [string]
```

### kilo auth logout

```
log out from a configured provider

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo agent

```
manage agents

Commands:
  kilo agent create  create a new agent
  kilo agent list    list all available agents

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo agent create

```
create a new agent

Options:
      --help                  Show help  [boolean]
      --version               Show version number  [boolean]
      --path                  directory path to generate the agent file  [string]
      --description           what the agent should do  [string]
      --mode                  agent mode  [string] [choices: "all", "primary", "subagent"]
      --permissions, --tools  comma-separated list of permissions to allow (default: all). Available: "bash, read, edit, glob, grep, webfetch, task, todowrite, websearch, lsp, skill"  [string]
  -m, --model                 model to use in the format of provider/model  [string]
```

### kilo agent list

```
list all available agents

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo upgrade

```
upgrade kilo to the latest or a specific version

Positionals:
  target  version to upgrade to, for ex '0.1.48' or 'v0.1.48'  [string]

Options:
      --help     Show help  [boolean]
      --version  Show version number  [boolean]
  -m, --method   installation method to use  [string] [choices: "curl", "npm", "yarn", "pnpm", "bun", "brew", "choco", "scoop"]
```

## kilo uninstall

```
uninstall kilo and remove all related files

Options:
      --help         Show help  [boolean]
      --version      Show version number  [boolean]
  -c, --keep-config  keep configuration files  [boolean] [default: false]
  -d, --keep-data    keep session data and snapshots  [boolean] [default: false]
      --dry-run      show what would be removed without removing  [boolean] [default: false]
  -f, --force        skip confirmation prompts  [boolean] [default: false]
```

## kilo serve

```
starts a headless kilo server

Options:
  --help         Show help  [boolean]
  --version      Show version number  [boolean]
  --port         port to listen on  [number] [default: 0]
  --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
  --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
  --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
  --cors         additional domains to allow for CORS  [array] [default: []]
```

## kilo web

```
start kilo server and open web interface

Options:
  --help         Show help  [boolean]
  --version      Show version number  [boolean]
  --port         port to listen on  [number] [default: 0]
  --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
  --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
  --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
  --cors         additional domains to allow for CORS  [array] [default: []]
```

## kilo models

```
list all available models

Positionals:
  provider  provider ID to filter models by  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --verbose  use more verbose model output (includes metadata like costs)  [boolean]
  --refresh  refresh the models cache from models.dev  [boolean]
```

## kilo roll-call

```
batch-test text models matching a filter for connectivity and latency

Positionals:
  filter  regex to filter models by provider/modelID (required)  [string]

Options:
  --help      Show help  [boolean]
  --version   Show version number  [boolean]
  --prompt    Prompt to send to each model  [string] [default: "Hello"]
  --timeout   Timeout for each model call in milliseconds  [number] [default: 25000]
  --parallel  Number of parallel model calls  [number] [default: 5]
  --verbose   Show verbose output  [boolean] [default: false]
  --quiet     Suppress progress and decoration  [boolean] [default: false]
  --output    Output format (table, json, or md)  [string] [choices: "table", "json", "md"] [default: "table"]
```

## kilo profile

```
show Kilo account profile

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --json     output profile as JSON  [boolean] [default: false]
```

## kilo stats

```
show token usage and cost statistics

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --days     show stats for the last N days (default: all time)  [number]
  --tools    number of tools to show (default: all)  [number]
  --models   show model statistics (default: hidden). Pass a number to show top N, otherwise shows all
  --project  filter by project (default: all projects, empty string: current project)  [string]
```

## kilo export

```
export session data as JSON

Positionals:
  sessionID  session id to export  [string]

Options:
  --help      Show help  [boolean]
  --version   Show version number  [boolean]
  --sanitize  redact sensitive transcript and file data  [boolean]
```

## kilo import

```
import session data from JSON file or URL

Positionals:
  file  path to JSON file or share URL  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo github

```
manage GitHub agent

Commands:
  kilo github install  install the GitHub agent
  kilo github run      run the GitHub agent

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo github install

```
install the GitHub agent

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo github run

```
run the GitHub agent

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --event    GitHub mock event to run the agent for  [string]
  --token    GitHub personal access token (github_pat_********)  [string]
```

## kilo pr

```
fetch and checkout a GitHub PR branch, then run kilo

Positionals:
  number  PR number to checkout  [number]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo session

```
manage sessions

Commands:
  kilo session list                list sessions
  kilo session delete <sessionID>  delete a session

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo session list

```
list sessions

Options:
      --help       Show help  [boolean]
      --version    Show version number  [boolean]
  -n, --max-count  limit to N most recent sessions  [number]
      --format     output format  [string] [choices: "table", "json"] [default: "table"]
  -a, --all        list sessions from all projects  [boolean] [default: false]
  -s, --search     filter sessions by title  [string]
```

### kilo session delete

```
delete a session

Positionals:
  sessionID  session ID to delete  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo remote

```
enable remote connection for real-time session relay

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo daemon

```
manage the local kilo daemon

Commands:
  kilo daemon start    start the local kilo daemon
  kilo daemon status   show local kilo daemon status
  kilo daemon stop     stop the local kilo daemon
  kilo daemon restart  restart the local kilo daemon

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo daemon start

```
start the local kilo daemon

Options:
  --help         Show help  [boolean]
  --version      Show version number  [boolean]
  --port         port to listen on  [number] [default: 0]
  --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
  --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
  --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
  --cors         additional domains to allow for CORS  [array] [default: []]
  --json         print daemon details as JSON  [boolean]
```

### kilo daemon status

```
show local kilo daemon status

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --json     print daemon details as JSON  [boolean]
```

### kilo daemon stop

```
stop the local kilo daemon

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --json     print daemon details as JSON  [boolean]
```

### kilo daemon restart

```
restart the local kilo daemon

Options:
  --help         Show help  [boolean]
  --version      Show version number  [boolean]
  --port         port to listen on  [number] [default: 0]
  --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
  --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
  --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
  --cors         additional domains to allow for CORS  [array] [default: []]
  --json         print daemon details as JSON  [boolean]
```

## kilo console

```
open the local Kilo Console

Options:
  --help         Show help  [boolean]
  --version      Show version number  [boolean]
  --port         port to listen on  [number] [default: 0]
  --hostname     hostname to listen on  [string] [default: "127.0.0.1"]
  --mdns         enable mDNS service discovery (defaults hostname to 0.0.0.0)  [boolean] [default: false]
  --mdns-domain  custom domain name for mDNS service (default: kilo.local)  [string] [default: "kilo.local"]
  --cors         additional domains to allow for CORS  [array] [default: []]
```

## kilo db

```
database tools

Commands:
  kilo db [query]     open an interactive sqlite3 shell or run a query  [default]
  kilo db path        print the database path
  kilo db migrate     migrate JSON data to SQLite (merges with existing data)

Positionals:
  query  SQL query to execute  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --format   Output format  [string] [choices: "json", "tsv"] [default: "tsv"]
```

### kilo db path

```
print the database path

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo db migrate

```
migrate JSON data to SQLite (merges with existing data)

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo config

```
configuration tools

Commands:
  kilo config check  check configuration for warnings and errors

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

### kilo config check

```
check configuration for warnings and errors

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```

## kilo plugin

```
install plugin and update config

Positionals:
  module  npm module name  [string]

Options:
      --help     Show help  [boolean]
      --version  Show version number  [boolean]
  -g, --global   install in global config  [boolean] [default: false]
  -f, --force    replace existing plugin version  [boolean] [default: false]
```

## kilo help

```
show full CLI reference

Positionals:
  command  command to show help for  [string]

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
  --all      show help for all commands  [boolean] [default: false]
  --format   output format  [string] [choices: "md", "text"] [default: "md"]
```

## kilo completion

```
generate shell completion script

Options:
  --help     Show help  [boolean]
  --version  Show version number  [boolean]
```
